#include "common.h"

int g_resolution = 144;//dpi
char iniFile[PATH_LENGTH];
char cacheFile[PATH_LENGTH];
char cacheFile_temp[PATH_LENGTH];
HANDLE g_hModule;
int g_isUseTemp = 0;
void loadConfig()
{
	GetModuleFileName((HMODULE)g_hModule, iniFile, PATH_LENGTH);
	strcpy(cacheFile, iniFile);
	strcpy(iniFile+strlen(iniFile)-4, ".ini");
	g_resolution = GetPrivateProfileInt("Setting", "DPI", g_resolution, iniFile);
	g_isUseTemp = GetPrivateProfileInt("Setting", "USETEMP", g_isUseTemp, iniFile);
	if (g_isUseTemp) {
		char temp[PATH_LENGTH];
		strcpy(temp, getFilename(cacheFile));
		GetTempPath(PATH_LENGTH, cacheFile);
		strcat(cacheFile, temp);
	}
	strcat(cacheFile, ".dbz");
	strcpy(cacheFile_temp, cacheFile);
	strcat(cacheFile_temp, "_temp");
}
int getPasswordSuggest(int num, char *buf, int len)
{
	if (num < 0) num = -num;
	char key[64];
	sprintf(key, "PASS%d", num);
	GetPrivateProfileString("Password", key, "", buf, len, iniFile);
	return num+1;
}

CommonCache::CommonCache()
{
	llog("Construtor");
	//now_footer = NULL;
	now_header = new struct CommonCache_Header;
	now_info = new struct CommonCache_Info;
	memset(now_header, 0, sizeof(*now_header));
	now_header->resolution = g_resolution;
	FILE *fp = fopen(cacheFile, "rb");
	if (fp == NULL) {
		llog("ReadFailed");
		return;
	}
	fread(now_header, sizeof(*now_header), 1, fp);
	if (now_header->file_sum) {
		delete now_info;
		now_info = new struct CommonCache_Info[now_header->file_sum];
		fread(now_info, sizeof(*now_info), now_header->file_sum, fp);
		now_header->start_addr = sizeof(*now_info)*now_header->file_sum + sizeof(*now_header);
	}
	fclose(fp);
}
CommonCache::~CommonCache()
{
	delete now_header;
	delete now_info;
}
void CommonCache::Init(char *archivename)
{
	if ( (strcmp(now_header->name, "") == 0) || (strcmp(now_header->name, archivename)!=0) || (now_header->resolution != g_resolution) ) {
		sprintf(temp, "ReCreate Cache:[%s]=>[%s]", now_header->name, archivename);
		llog(temp);
		Clear();
		strcpy(now_header->name, archivename);

		FILE *fp = fopen(cacheFile, "wb");
		fwrite(now_header, sizeof(*now_header), 1, fp);
		fclose(fp);
	}
}
void CommonCache::Clear()
{
	memset(now_header, 0, sizeof(*now_header));
	now_header->resolution = g_resolution;
	delete now_info;
	now_info = new struct CommonCache_Info;
}
//hJpegɃt@Cf[^Ă
void CommonCache::Add(char *archivename, HLOCAL *hFile, unsigned long *filesize, unsigned long position)
{
	llog("Add");
	struct CommonCache_Info *pinfo, *p;
	Init(archivename);
	unsigned long addr = 0;
	unsigned long old_start_addr = now_header->start_addr;
	for (unsigned long i=0;i<now_header->file_sum;i++) {
		p = &now_info[i];
		//printf("p:%d,a:%x,s:%x\n", p->position, p->addr, p->size);
		if (p->position == position) {
			llog("NoAdd");
			return;
		}
		addr = p->addr + p->size;
	}
	//printf("position:%d\n", position);
	//printf("addr:%x\n", addr);
	unsigned long len = now_header->file_sum += 1;
	pinfo = new struct CommonCache_Info[len];
	memcpy(pinfo, now_info, sizeof(*pinfo)*(len-1));
	pinfo[len-1].position = position;
	pinfo[len-1].size = *filesize;
	pinfo[len-1].addr = addr;

	now_header->start_addr = sizeof(*pinfo)*len + sizeof(*now_header);

	FILE *fp = fopen(cacheFile_temp, "wb");
	FILE *fp2 = fopen(cacheFile, "rb");
	if (fp == NULL || fp2 == NULL) {
		if (fp!=NULL) fclose(fp);
		if (fp2!=NULL) fclose(fp2);
		llog("cache open error");
		return;
	}
	fseek(fp, 0, SEEK_SET);
	fwrite(now_header, sizeof(*now_header), 1, fp);
	sprintf(temp, "len:%d", len);
	llog(temp);
	fwrite(pinfo, sizeof(*pinfo), len, fp);
	if (len > 1) {
		for (unsigned long i=0;i<len-1;i++) {
			p = &now_info[i];
			fseek(fp2, p->addr+old_start_addr, SEEK_SET);
			unsigned int s = p->size;
			while (s--) {
				int c = getc(fp2);
				putc(c, fp);
			}
		}
	}
	fwrite(*hFile, sizeof(unsigned char), *filesize, fp);

	delete now_info;
	now_info = pinfo;

	//free(pfooter);
	fclose(fp);
	fclose(fp2);

	remove(cacheFile);
	llog("rename");
	if (rename(cacheFile_temp, cacheFile)) {
		llog("rename failed");
	}
}
//pinfoŎw肵positioñt@ChFileɓ(LocalAlloc)
int CommonCache::Get(char *archivename, HLOCAL *hFile, unsigned long *filesize, unsigned long position)
{
	llog("Get");
	struct CommonCache_Info *p=NULL;
	Init(archivename);
	for (unsigned long i=0;i<now_header->file_sum;i++) {
		p = &now_info[i];
		printf("p:%d,a:%x,s:%x\n", p->position, p->addr, p->size);
		if (p->position == position) {
			llog("Found");
			break;
		}
		p = NULL;
	}
	if (p == NULL) {
		return false;
	}
	*filesize = p->size;
	*hFile = LocalAlloc(LMEM_FIXED, *filesize);
	FILE *fp = fopen(cacheFile, "rb");
	printf("%x\n", p->addr+now_header->start_addr);
	fseek(fp, p->addr+now_header->start_addr, SEEK_SET);
	fread(*hFile, sizeof(unsigned char), *filesize, fp);
	fclose(fp);
	return true;
}
void CommonCache::AddPassword(char *archivename, char *pass)
{
	strcpy(now_header->pass, pass);
}
char* CommonCache::GetPassword(char *archivename)
{
	return now_header->pass;
}
int CommonCache::Dupli(char *archivename, HLOCAL *lphInf)
{
	if (now_header->file_sum == 0) {
		return SPI_NO_FUNCTION;
	}

	int fcount = now_header->file_sum;
	*lphInf = LocalAlloc(LPTR, sizeof(fileInfo)*(fcount+1));
	if (*lphInf == NULL) {
		return SPI_NO_MEMORY;
	}
	fileInfo *pinfo = (fileInfo*)*lphInf;
	for (int i=0;i<fcount;i++) {
		lstrcpy((char*)pinfo->method, "MuPDF");
		pinfo->position = i;
		pinfo->compsize = now_info[i].size;
		pinfo->filesize = now_info[i].size;
		pinfo->timestamp = 0;
		sprintf((char*)pinfo->filename, "%03d.jpg", i);
		pinfo->crc = 0;
		pinfo++;
	}
	pinfo->method[0] = '\0';
	return SPI_ALL_RIGHT;
}

int GetArchiveInfoExCache(LPSTR filename, long len, HLOCAL *lphInf, CommonCache *cache)
{
	pdf_xref *xref;
	pdf_page *page;
	int fcount = 0;
	unsigned long filesize;
	fz_error error;

	error = pdf_open_xref(&xref, filename, NULL);
	if (error) { return SPI_FILE_READ_ERROR;}
	if (pdf_needs_password(xref)) {
		llog("NeedPassword");
		int num=0;
		char pass[PASS_LENGTH];
		while (1) {
			num = getPasswordSuggest(num, pass, PASS_LENGTH);
			if (pass[0] == '\0') break;
			if (pdf_authenticate_password(xref, pass)) {
				llog("Password OK");
				cache->AddPassword(filename, pass);
				break;
			}
		}
		if (pass[0] == '\0') {
			pdf_free_xref(xref);
			return SPI_FILE_READ_ERROR;
		}
	}
	error = pdf_load_page_tree(xref);
	if (error) { 
		pdf_free_xref(xref);
		return SPI_FILE_READ_ERROR;
	}
	fcount = pdf_count_pages(xref);
	*lphInf = LocalAlloc(LPTR, sizeof(fileInfo)*(fcount+1));
	if (*lphInf == NULL) {
		pdf_free_xref(xref);
		return SPI_NO_MEMORY;
	}
	fileInfo *pinfo = (fileInfo *)*lphInf;
	HLOCAL dest;
	for (int i=0; i < fcount; i++) {
		error = pdf_load_page(&page, xref, i);
		int ret = GetJpegToMemory(&dest, &filesize, xref, page, g_resolution);
		pdf_free_page(page);
		if (ret != 0) { pdf_free_xref(xref); cache->Clear(); return ret;}
		cache->Add(filename, &dest, &filesize, i);
		LocalFree(dest);
		/* Method(7+'\0'ȓł̓Kȕԋp) */
		lstrcpy((char*)pinfo->method, "MuPDF");
		pinfo->position = i;
		pinfo->compsize = filesize;
		pinfo->filesize = filesize;
		pinfo->timestamp = 0;
		sprintf((char*)pinfo->filename, "%03d.jpg", i);
		pinfo->crc = 0;
		pinfo++;
	}
	pinfo->method[0] = '\0';
	pdf_free_xref(xref);
	return SPI_ALL_RIGHT;
}

int GetJpegToMemory(HLOCAL *hLocal, unsigned long *buf_size, pdf_xref *xref, pdf_page *page, int resolution)
{
	fz_display_list *list;
	fz_device *dev;
	fz_colorspace *colorspace = fz_device_rgb;
	struct jpeg_compress_struct cinfo;
	struct jpeg_error_mgr jerr;
	JSAMPARRAY img;

	cinfo.err = jpeg_std_error(&jerr);

	jpeg_create_compress(&cinfo);
	float zoom;
	fz_matrix ctm;
	fz_bbox bbox;
	fz_pixmap *pix;
	fz_glyph_cache_s *glyphcache;

	zoom = (float)resolution / 72;
	ctm = fz_translate(0, -page->mediabox.y1);
	ctm = fz_concat(ctm, fz_scale(zoom, -zoom));
	ctm = fz_concat(ctm, fz_rotate(page->rotate));
	bbox = fz_round_rect(fz_transform_rect(ctm, page->mediabox));

	pix = fz_new_pixmap_with_rect(colorspace, bbox);
	fz_clear_pixmap_with_color(pix, 255);

	glyphcache = fz_new_glyph_cache();
	dev = fz_new_draw_device(glyphcache, pix);
	pdf_run_page(xref, page, dev, ctm);
	fz_free_device(dev);
	fz_free_glyph_cache(glyphcache);

	cinfo.image_width = pix->w;
	cinfo.image_height = pix->h;
	cinfo.input_components = 3;
	cinfo.in_color_space = JCS_RGB;
	jpeg_set_defaults(&cinfo);
	jpeg_set_quality(&cinfo, 100, TRUE);

	*buf_size = pix->w*pix->h*3;
	*hLocal = LocalAlloc(LMEM_FIXED, *buf_size);
	if (*hLocal == NULL) {
		return SPI_NO_MEMORY;
	}
	unsigned char * buf = (unsigned char *)*hLocal;

	jpeg_mem_dest(&cinfo, &buf, buf_size);
	jpeg_start_compress(&cinfo, TRUE);

	JSAMPROW row_pointer[1];
	JSAMPROW row;
	row = (JSAMPROW)malloc(sizeof(JSAMPLE)*pix->w*3);
	if (row == NULL) {
		fz_drop_pixmap(pix);
		jpeg_destroy_compress(&cinfo);
		return SPI_NO_MEMORY;
	}
	unsigned char *ps = pix->samples, *pd;
	for (int i=0;i<pix->h;i++) {
		pd = row;
		for (int j=0;j<pix->w;j++) {
			*(pd++) = *(ps++);
			*(pd++) = *(ps++);
			*(pd++) = *(ps++);
			ps++;
		}
		row_pointer[0] = row;
		jpeg_write_scanlines(&cinfo, row_pointer, 1);
	}

	jpeg_finish_compress(&cinfo);
	free(row);
	fz_drop_pixmap(pix);
	jpeg_destroy_compress(&cinfo);

	return 0;
}
char *getFilename(LPSTR filename)
{
	char *p = filename;
	int b = *p;
	for (int i=0,len=strlen(filename);i<len;i++) {
		if (filename[i] == '\\') {
			if (	(b == 0x81) ||
					(b >= 0x83 && b <= 0x9f) ||
					(b >= 0xe0 && b <= 0xea) ||
					(b == 0xed || b == 0xee) ||
					(b == 0xfa || b == 0xfb) ) {
				continue;
			}
			p = filename+i+1;
		}
		b = filename[i] & 0xFF;
	}
	return p;
}
#ifndef MY_COMMON_DEBUG
void llog(char *s){}
#else
void llog(char *s) { FILE *fp=fopen("r:/output.log", "a");fprintf(fp,"%s\n",s);fclose(fp);}
#endif
